#include<bits/stdc++.h>
using namespace std;
int s,n;
int dp[20007];
int a[2007];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>s>>n;
    for (int q=0;q<n;q++) cin>>a[q];
    sort(a,a+n);
    dp[0]=0;
    for (int q=1;q<=s;q++)
    {
       dp[q]=dp[q-1]+1;
       for (int w=1;w<n;w++)
       {
          if (a[w]<=q) dp[q]=min(dp[q],dp[q-a[w]]+1);
       }
    }
    cout<<dp[s]<<"\n";
}
